/*
 * Message.java
 *
 * Created on 21 maj 2007, 15:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package eu.bojar.hibernatetest.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

/**
 * Entity class Message
 * 
 * @author Jarek
 */
@Entity
public class Message implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
    private Long id;
    
    private String subject;

    @ManyToOne(fetch = FetchType.LAZY)
    private Message previous;
    
    @OneToMany(fetch = FetchType.LAZY, mappedBy = "previous")
    private Set<Message> next = new HashSet<Message>();

    public Message() {
    }
    
    public Message(Long id, String subject) {
    	this.id = id;
        this.subject = subject;
    }

    public Message(Long id, String subject, Message previous) {
		this.id = id;
		this.subject = subject;
		this.previous = previous;
	}

    public Long getId() {
        return this.id;
    }
    
    public void setId(Long id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Message)) {
            return false;
        }
        Message other = (Message)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    /**
     * Returns a string representation of the object.  This implementation constructs 
     * that representation based on the id fields.
     * @return a string representation of the object.
     */
    @Override
    public String toString() {
        return "eu.bojar.hibernatetest.Message[id=" + id + "]";
    }

    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

	public Message getPrevious() {
		return previous;
	}

	public void setPrevious(Message previous) {
		this.previous = previous;
	}

	public Set<Message> getNext() {
		return next;
	}

	public void setNext(Set<Message> next) {
		this.next = next;
	}

}
